;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Definitions for the donkey menu into DrScheme.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define drscheme-loaded #t)
(define donkey-loaded #f)
(define drscheme-started-first #t)
(define on-donkey
  (lambda args
    (if donkey-loaded
	(send f-frame show #t)
	(begin
	  (load/cd (build-path drscheme:donkey-home-directory "donkey.zo"))
	  (set! drscheme-loaded #t)
	  (set! donkey-loaded #t)
	  (donkey:go)
	  (send f-frame delete-dr-start)))))

(define load-donkey
  (lambda ()
    (if donkey-loaded
	(letrec ([dr-edit (send drscheme:frame get-program-edit)]
		 [scan
		  (lambda (l)
		    (if (null? l) void
			(begin
			  (send dr-edit insert (send (ivar (car l) fedit) get-text))
			  (send dr-edit insert #\newline)
			  (send dr-edit insert #\newline)
			  (scan (cdr l)))))])
	  (scan blk-list)))))

(define donkey:create-menu-bar-hook
  (lambda (menu)
    (let ([donkey-menu (make-object mred:menu%)])
      (send* donkey-menu (append-item "Step"
				      on-donkey "Switch to Stepper")
   	                 (append-item "Copy From Stepper"
				      load-donkey "Copy Text from Stepper"))
      (send menu append donkey-menu "Stepper"))))
