;;
;; mzprizm:transform
;;         |
;; mzprizm:color-syntax
;;         |
;; 1. mzprizm:find-locs-and-color:
;;    a. mzprizm:find-word-begin } mzprizm:spaces-list
;;    b. mzprizm:find-word-break } 
;; 2. mzprizm:const-delta, mzprizm:keyword-delta, etc.
;;    a. mzprizm:make-delta
;;       (i). mzprizm:delta-add-string!
;;    b. mzprizm:x-color, mzprizm:x-underline?, mzprizm:x-bold?,
;;       mzprizm:x-italic?, mzprizm:x-font
;;       (i). mzprizm:default-x-y
;;       (ii). (mzprizm:x-color --> mzprizm:make-color-string)
;; 3. mzprizm:primitive-list
;; 

(define mzprizm:default-const-color 'green)
(define mzprizm:default-keyword-color 'black)
(define mzprizm:default-unbound-var-color 'red)
(define mzprizm:default-lex-var-color 'blue)
(define mzprizm:default-primitive-color 'orange)

(define mzprizm:default-const-underline? #f)
(define mzprizm:default-keyword-underline? #f)
(define mzprizm:default-unbound-var-underline? #t)
(define mzprizm:default-lex-var-underline? #f)
(define mzprizm:default-primitive-underline? #f)

(define mzprizm:default-const-bold? #f)
(define mzprizm:default-keyword-bold? #t)
(define mzprizm:default-unbound-var-bold? #t)
(define mzprizm:default-lex-var-bold? #f)
(define mzprizm:default-primitive-bold? #f)

(define mzprizm:default-const-italic? #f)
(define mzprizm:default-keyword-italic? #f)
(define mzprizm:default-unbound-var-italic? #f)
(define mzprizm:default-lex-var-italic? #t)
(define mzprizm:default-primitive-italic? #f)

(define mzprizm:default-const-font "wx:const-swiss")
(define mzprizm:default-keyword-font "wx:const-modern")
(define mzprizm:default-unbound-var-font "wx:const-modern")
(define mzprizm:default-lex-var-font "wx:const-modern")
(define mzprizm:default-primitive-font "wx:const-modern")

; -----------------------------------------------------------------------

(define mzprizm:make-color-string
  (lambda (color)
    (string-append "\""
		   (symbol->string color)
		   "\"")))

;;
;; the following five sections define
;; mzprizm:x-y
;;     x in {const, keyword, lex-var, unbound-var}
;;     y in {color, underline?, bold?, italic?, font}
;;

(define mzprizm:const-color
  (if (defined? 'mzprizm:const-color)
      (mzprizm:make-color-string mzprizm:const-color)
      (mzprizm:make-color-string mzprizm:default-const-color)))

(define mzprizm:keyword-color
  (if (defined? 'mzprizm:keyword-color)
      (mzprizm:make-color-string mzprizm:keyword-color)
      (mzprizm:make-color-string mzprizm:default-keyword-color)))

(define mzprizm:unbound-var-color
  (if (defined? 'mzprizm:unbound-var-color)
      (mzprizm:make-color-string mzprizm:unbound-var-color)
      (mzprizm:make-color-string mzprizm:default-unbound-var-color)))

(define mzprizm:lex-var-color
  (if (defined? 'mzprizm:lex-var-color)
      (mzprizm:make-color-string mzprizm:lex-var-color)
      (mzprizm:make-color-string mzprizm:default-lex-var-color)))

(define mzprizm:primitive-color
  (if (defined? 'mzprizm:primitive-color)
      (mzprizm:make-color-string mzprizm:primitive-color)
      (mzprizm:make-color-string mzprizm:default-primitive-color)))

; -----------------------------------------------------------------------

(define mzprizm:const-underline?
  (if (defined? 'mzprizm:const-underline?)
      mzprizm:const-underline?
      mzprizm:default-const-underline?))

(define mzprizm:keyword-underline?
  (if (defined? 'mzprizm:keyword-underline?)
      mzprizm:keyword-underline?
      mzprizm:default-keyword-underline?))

(define mzprizm:lex-var-underline?
  (if (defined? 'mzprizm:lex-var-underline?)
      mzprizm:lex-var-underline?
      mzprizm:default-lex-var-underline?))

(define mzprizm:unbound-var-underline?
  (if (defined? 'mzprizm:unbound-var-underline?)
      mzprizm:unbound-var-underline?
      mzprizm:default-unbound-var-underline?))

(define mzprizm:primitive-underline?
  (if (defined? 'mzprizm:primitive-underline?)
      mzprizm:primitive-underline?
      mzprizm:default-primitive-underline?))

; -----------------------------------------------------------------------

(define mzprizm:const-bold?
  (if (defined? 'mzprizm:const-bold?)
      mzprizm:const-bold?
      mzprizm:default-const-bold?))

(define mzprizm:keyword-bold?
  (if (defined? 'mzprizm:keyword-bold?)
      mzprizm:keyword-bold?
      mzprizm:default-keyword-bold?))

(define mzprizm:lex-var-bold?
  (if (defined? 'mzprizm:lex-var-bold?)
      mzprizm:lex-var-bold?
      mzprizm:default-lex-var-bold?))

(define mzprizm:unbound-var-bold?
  (if (defined? 'mzprizm:unbound-var-bold?)
      mzprizm:unbound-var-bold?
      mzprizm:default-unbound-var-bold?))

(define mzprizm:primitive-bold?
  (if (defined? 'mzprizm:primitive-bold?)
      mzprizm:primitive-bold?
      mzprizm:default-primitive-bold?))

; -----------------------------------------------------------------------

(define mzprizm:const-italic?
  (if (defined? 'mzprizm:const-italic?)
      mzprizm:const-italic?
      mzprizm:default-const-italic?))

(define mzprizm:keyword-italic?
  (if (defined? 'mzprizm:keyword-italic?)
      mzprizm:keyword-italic?
      mzprizm:default-keyword-italic?))

(define mzprizm:lex-var-italic?
  (if (defined? 'mzprizm:lex-var-italic?)
      mzprizm:lex-var-italic?
      mzprizm:default-lex-var-italic?))

(define mzprizm:unbound-var-italic?
  (if (defined? 'mzprizm:unbound-var-italic?)
      mzprizm:unbound-var-italic?
      mzprizm:default-unbound-var-italic?))

(define mzprizm:primitive-italic?
  (if (defined? 'mzprizm:primitive-italic?)
      mzprizm:primitive-italic?
      mzprizm:default-primitive-italic?))

; -----------------------------------------------------------------------

(define mzprizm:const-font
  (if (defined? 'mzprizm:const-font)
      mzprizm:const-font
      mzprizm:default-const-font))

(define mzprizm:keyword-font
  (if (defined? 'mzprizm:keyword-font)
      mzprizm:keyword-font
      mzprizm:default-keyword-font))

(define mzprizm:lex-var-font
  (if (defined? 'mzprizm:lex-var-font)
      mzprizm:lex-var-font
      mzprizm:default-lex-var-font))

(define mzprizm:unbound-var-font
  (if (defined? 'mzprizm:unbound-var-font)
      mzprizm:unbound-var-font
      mzprizm:default-unbound-var-font))

(define mzprizm:primitive-font
  (if (defined? 'mzprizm:primitive-font)
      mzprizm:primitive-font
      mzprizm:default-primitive-font))

; -----------------------------------------------------------------------

;; mzprizm:delta-add-string! comes directly from cormac's
;; delta-add-string!.

(define mzprizm:delta-add-string! 
  (lambda (delta string)
  (let ([p (open-input-string string)])
    (recur loop ()
      (let ([e (read p)])
        (unless (eof-object? e)
          (apply (uq-ivar delta (car e)) (eval `(list ,@(cdr e))))
          (loop)))))))


(define mzprizm:make-bw-delta-string
  (lambda (font underline? bold? italic?)
    (if (wx:colour-display?)
	""
	(let* ([font-string (string-append "(set-delta wx:const-change-family "
					   font ") ")]
	       [underline-string (if underline?
				     "(set-delta wx:const-change-underline 1) "
				     "")]
	       [bold-string (if bold?
				"(set-delta wx:const-change-bold) "
				"")]
	       [italic-string (if italic?
				  "(set-delta wx:const-change-italic 1)"
				  "")])
	  (string-append font-string
			 underline-string
			 bold-string
			 italic-string)))))

(define mzprizm:make-color-delta-string
  (lambda (color)
    (if (wx:colour-display?)
	(string-append "(set-delta-foreground "
		       color ") ")
	"")))

(define mzprizm:make-delta
  (lambda (color font underline? bold? italic?)
    (let* ([delta (make-object wx:style-delta% 
			       wx:const-change-alignment wx:const-align-top)]
	   [color-delta-string (mzprizm:make-color-delta-string color)]
;	    (if (wx:colour-display?)
;			     (string-append "(set-delta-foreground "
;					    color ") ")
;			     "")]
	   [bw-delta-string (mzprizm:make-bw-delta-string
			     font underline? bold? italic?)]
;	   [font-string (string-append "(set-delta wx:const-change-family "
;				       font ") ")]
;	   [underline-string (if underline?
;				 "(set-delta wx:const-change-underline 1) "
;				 "")]
;	   [bold-string (if bold?
;			    "(set-delta wx:const-change-bold) "
;			    "")]
;	   [italic-string (if italic?
;			      "(set-delta wx:const-change-italic 1)"
;			      "")]
	   [delta-string (string-append color-delta-string
					bw-delta-string)])
;					font-string
;					underline-string
;					bold-string
;					italic-string)])
      (mzprizm:delta-add-string! delta delta-string)
      delta)))

;; ----------------------------------------------------------------------

(define mzprizm:const-delta
  (mzprizm:make-delta mzprizm:const-color
		       mzprizm:const-font
		       mzprizm:const-underline?
		       mzprizm:const-bold?
		       mzprizm:const-italic?))

(define mzprizm:keyword-delta
  (mzprizm:make-delta mzprizm:keyword-color
		       mzprizm:keyword-font
		       mzprizm:keyword-underline?
		       mzprizm:keyword-bold?
		       mzprizm:keyword-italic?))

(define mzprizm:lex-var-delta
  (mzprizm:make-delta mzprizm:lex-var-color
		       mzprizm:lex-var-font
		       mzprizm:lex-var-underline?
		       mzprizm:lex-var-bold?
		       mzprizm:lex-var-italic?))

(define mzprizm:unbound-var-delta
  (mzprizm:make-delta mzprizm:unbound-var-color
		       mzprizm:unbound-var-font
		       mzprizm:unbound-var-underline?
		       mzprizm:unbound-var-bold?
		       mzprizm:unbound-var-italic?))

(define mzprizm:primitive-delta
  (mzprizm:make-delta mzprizm:primitive-color
		       mzprizm:primitive-font
		       mzprizm:primitive-underline?
		       mzprizm:primitive-bold?
		       mzprizm:primitive-italic?))
		       
;; ----------------------------------------------------------------------

;; find beginnings and endings of words
;; (useful in cases like define (zodiac returns set!), etc.)

(define mzprizm:spaces-list
  '(  #\space #\( #\) #\[ #\] 
	      #\newline #\; #\| #\" #\` #\' #\, ))

(define mzprizm:find-word-break
  (lambda (start-pos edit)
    (let 
         ( [last (send edit last-position)])
          
      (let loop ([first start-pos])
        (cond
         [(= first last) first]
         [(member (string-ref (send edit get-text first (add1 first)) 0 )
		  mzprizm:spaces-list)
          first]
         [else (loop (add1 first))])))))

(define mzprizm:find-word-begin
  (lambda (start-pos edit)
    (let ([buffer-end (send edit last-position)])
      (let loop ([first start-pos])
	(cond
	 [(= first buffer-end) first]
	 [(not (member (string-ref (send edit get-text first (add1 first)) 0)
		       mzprizm:spaces-list))
	  first]
	 [else (loop (add1 first))])))))

; -----------------------------------------------------------------------

(define mzprizm:primitive-list
  (list
   'list 'null?  'cons?  'atom?  'list?  'boolean?  'symbol?  'char? 'not
   'vector?  'structure?
   'pair?  'string?  'procedure?  'number?  'complex?  'real?
   'rational?  'integer?  'cons 'eq?  'eqv?  'equal?  'add1 'sub1 'zero?
   'exact?  'inexact?  '+ '- '* '/ 'odd?  'even?  'positive?
   'negative?  'symbol->string 'string->symbol 'abs 'length 'reverse
   'quotient 'remainder 'modulo 'gcd 'lcm 'numerator 'denominator 'floor
   'ceiling 'truncate 'round 'rationalize 'exp 'log 'sin 'cos 'tan 'asin
   'acos 'atan 'sqrt 'expt 'make-rectangular 'make-polar 'real-part
   'imag-part 'magnitude 'angle 'exact->inexact 'inexact->exact
   'number->string 'string->number 'memq 'memv 'member 'assq 'assv 'assoc
   'char=?  'char<?  'char<=?  'char>?  'char>=?  'char-ci=?  'char-ci<?
   'char-ci<=?  'char-ci>?  'char-ci>=?  'char-alphabetic?
   'char-numeric?  'char-whitespace?  'char-upper-case?
   'char-lower-case?  'char->integer 'integer->char 'char-upcase
   'char-downcase 'make-string 'string 'string-length 'string-ref
   'string=? 'string<? 'string>? 'string<=? 'string>=?
   'string-ci=? 'string-ci<? 'string-ci>? 'string-ci<=? 'string-ci>=?
   'list->string 'string->list 'string-append 'substring 'string-set!  
   'string-fill! 'string-copy 
   'vector 'make-vector 'vector-length 'vector-set! 'vector->list
   'list->vector 'vector-fill!
   'apply 'map 'for-each 'force
   'call-with-current-continuation 'call/cc
   'call-with-input-file  'call-with-output-file
   'with-input-from-file  'with-output-to-file
   'open-input-file  'open-output-file 'close-input-port  'close-output-port
   'current-input-port  'current-output-port 'input-port?  'output-port?
   'read 'read-char 'peek-char 'char-ready?   'eof-object?
   'write 'display 'write-char 'newline 'load 'transcript-on 'transcript-off
   '< '<= '= '> '>= 'max 'min 'length 'append 'reverse
   'list-ref 'list-tail 'vector-ref 'set-car!  'set-cdr!  'car 'cdr 'caar
   'cadr 'cdar 'cddr 'caaar 'caadr 'cadar 'caddr 'cdaar 'cdadr 'cddar
   'cdddr 'caaaar 'caaadr 'caadar 'caaddr 'cadaar 'cadadr 'caddar 'cadddr
   'cdaaar 'cdaadr 'cdadar 'cdaddr 'cddaar 'cddadr 'cdddar 'cddddr))


;; ----------------------------------------------------------------------

(define mzprizm:do-color
  (lambda (start finish edit delta)
    (send edit change-style delta start finish)))

(define mzprizm:find-locs-and-color
  (lambda (start-offset edit delta)
    (let* ([start (mzprizm:find-word-begin start-offset edit)]
	   [finish (mzprizm:find-word-break start edit)])
      (mzprizm:do-color start finish edit delta))))


(define mzprizm:color-syntax
  (lambda (zodiac-ast edit)
    (cond

     [(zodiac:string? zodiac-ast)
      (mzprizm:do-color (zodiac:location-offset
			  (zodiac:string-start zodiac-ast))
			 (zodiac:location-offset
			  (zodiac:string-finish zodiac-ast))
			 edit
			 mzprizm:const-delta)]
     
     [(zodiac:boolean? zodiac-ast)
      (mzprizm:do-color (zodiac:location-offset
			  (zodiac:boolean-start zodiac-ast))
			 (zodiac:location-offset
			  (zodiac:boolean-finish zodiac-ast))
			 edit
			 mzprizm:const-delta)]
     
     [(zodiac:char? zodiac-ast)
      (mzprizm:do-color (zodiac:location-offset
			  (zodiac:char-start zodiac-ast))
			 (zodiac:location-offset
			  (zodiac:char-finish zodiac-ast))
			 edit
			 mzprizm:const-delta)]
     
     [(zodiac:symbol? zodiac-ast)
      (mzprizm:do-color (zodiac:location-offset
			  (zodiac:symbol-start zodiac-ast))
			 (zodiac:location-offset
			  (zodiac:symbol-finish zodiac-ast))
			 edit
			 mzprizm:const-delta)]
     
     [(zodiac:number? zodiac-ast)
      (mzprizm:do-color (zodiac:location-offset
			  (zodiac:number-start zodiac-ast))
			 (zodiac:location-offset
			  (zodiac:number-finish zodiac-ast))
			 edit
			 mzprizm:const-delta)]
     
     [(zodiac:bound? zodiac-ast)
      (mzprizm:find-locs-and-color (zodiac:location-offset
				     (zodiac:symbol-start
				      (zodiac:bound-var zodiac-ast)))
				    edit
				    mzprizm:lex-var-delta)]
     
     [(zodiac:lexical-varref? zodiac-ast)
      (mzprizm:find-locs-and-color (zodiac:location-offset
				     (zodiac:symbol-start
				      (zodiac:lexical-varref-var zodiac-ast)))
				    edit
				    mzprizm:lex-var-delta)]
     
     [(zodiac:unbound-varref? zodiac-ast)
      (mzprizm:find-locs-and-color (zodiac:location-offset
				     (zodiac:symbol-start
				      (zodiac:unbound-varref-var zodiac-ast)))
				    edit
;; primitive?
				    (if (member
					 (zodiac:symbol-text
					  (zodiac:unbound-varref-var zodiac-ast))
					 mzprizm:primitive-list)
					mzprizm:primitive-delta
					mzprizm:unbound-var-delta))]
     
     [(zodiac:list? zodiac-ast)
      (map (lambda (x) (mzprizm:color-syntax x edit))
	   (zodiac:list-contents zodiac-ast))]
     
     [(zodiac:delay-form? zodiac-ast)
      (begin
	[mzprizm:find-locs-and-color (zodiac:location-offset
				       (zodiac:delay-form-open zodiac-ast))
				      edit
				      mzprizm:keyword-delta]
	[mzprizm:color-syntax (zodiac:delay-form-expr zodiac-ast) edit])]
     
     [(zodiac:if-form? zodiac-ast)
      (begin
	[mzprizm:find-locs-and-color (zodiac:location-offset
				       (zodiac:if-form-open zodiac-ast))
				      edit
				      mzprizm:keyword-delta]
	[mzprizm:color-syntax (zodiac:if-form-test zodiac-ast) edit]
	[mzprizm:color-syntax (zodiac:if-form-then zodiac-ast) edit]
	[mzprizm:color-syntax (zodiac:if-form-else zodiac-ast) edit])]
     
     [(zodiac:lambda-form? zodiac-ast)
      (begin
	[mzprizm:find-locs-and-color (zodiac:location-offset
				       (zodiac:lambda-form-open zodiac-ast))
				      edit
				      mzprizm:keyword-delta]
	[zodiac:improper-map (lambda (x) (mzprizm:color-syntax x edit))
			     (zodiac:lambda-form-args zodiac-ast)]
	[mzprizm:color-syntax (zodiac:lambda-form-body zodiac-ast) edit])]
     
;;set!-form includes define
     [(zodiac:set!-form? zodiac-ast)
      (begin
	[mzprizm:find-locs-and-color (zodiac:location-offset
				       (zodiac:set!-form-open zodiac-ast))
				      edit
				      mzprizm:keyword-delta]
	[mzprizm:color-syntax (zodiac:set!-form-var zodiac-ast) edit]
	[mzprizm:color-syntax (zodiac:set!-form-val zodiac-ast) edit])]
     
     [(zodiac:quote-form? zodiac-ast)
      (begin
	[mzprizm:find-locs-and-color (zodiac:location-offset
			    (zodiac:quote-form-open zodiac-ast))
				      edit
				      mzprizm:keyword-delta]
	[mzprizm:color-syntax (zodiac:quote-form-expr zodiac-ast) edit])]
     
     [(zodiac:begin-form? zodiac-ast)
      (begin
	[mzprizm:find-locs-and-color (zodiac:location-offset
				       (zodiac:begin-form-open zodiac-ast))
				      edit
				      mzprizm:keyword-delta]
	[mzprizm:color-syntax (zodiac:begin-form-first zodiac-ast) edit]
	[mzprizm:color-syntax (zodiac:begin-form-rest zodiac-ast) edit])]
     
     [(zodiac:let-form? zodiac-ast)
      (begin
	[mzprizm:find-locs-and-color (zodiac:location-offset
				       (zodiac:let-form-open zodiac-ast))
				      edit
				      mzprizm:keyword-delta]
	[map (lambda (x) (mzprizm:color-syntax x edit))
	     (zodiac:let-form-vars zodiac-ast)]
	[map (lambda (x) (mzprizm:color-syntax x edit))
	     (zodiac:let-form-vals zodiac-ast)]
	[mzprizm:color-syntax (zodiac:let-form-body zodiac-ast) edit])]
     
     [(zodiac:letrec-form? zodiac-ast)
      (begin
	[mzprizm:find-locs-and-color (zodiac:location-offset
				       (zodiac:letrec-form-open zodiac-ast))
				      edit
				      mzprizm:keyword-delta]
	[map (lambda (x) (mzprizm:color-syntax x edit))
	     (zodiac:letrec-form-vars zodiac-ast)]
	[map (lambda (x) (mzprizm:color-syntax x edit))
	     (zodiac:letrec-form-vals zodiac-ast)]
	[mzprizm:color-syntax (zodiac:letrec-form-body zodiac-ast) edit])]
     
     [(zodiac:app? zodiac-ast)
      (begin
	[mzprizm:color-syntax (zodiac:app-fun zodiac-ast) edit]
	[map (lambda (x) (mzprizm:color-syntax x edit))
	     (zodiac:app-args zodiac-ast)])]
     
     [else
      (wx:message-box (string-append "System error: unrecognized syntax"
				     (make-string 1 #\newline)
				     "MZPRIZM BUG"))])))


;; ----------------------------------------------------------------------

(define frame->edit
  (lambda (frame)
    (if frame
	(send (ivar frame program-canvas) get-media)
	#f)))

;;
;; modified aries:transform
;;

(define mzprizm:transform
  (let ((input-port? input-port?) (open-input-file open-input-file)
	 (current-eval current-eval) (list list))
    (lambda (filename/port frame)
      (let ([edit (frame->edit frame)]
	    [reader (zodiac:read
		      (if (input-port? filename/port)
			filename/port
			(open-input-file filename/port))
		      (make-zodiac:location
			(zodiac:location-line zodiac:default-scan-offset)
			(zodiac:location-column zodiac:default-scan-offset)
			(zodiac:location-offset zodiac:default-scan-offset)
			filename/port))])
	(begin0
	 (let read-loop ()
	   (let ((expr (reader)))
	     (if (zodiac:eof? expr)
		 'do-nothing-just-return-control-to-the-caller
		 (let ((expanded (zodiac:expand expr)))
		   (send edit begin-edit-sequence)
		   
;; in case of any terminal bugs in mzprizm:color-syntax,
;; (send edit end-edit-sequence) and zodiac:transmit-to-device remain
;; unevaluated.
		   
;; not evaluating (send edit end-edit-sequence) causes drscheme
;; to hang
		   
;; (not evaluating the call to zodiac:transmit-to-device causes the 
;; clock prompt to remain in the REP window -- this is relatively minor
;; since drscheme would already have hung anyway)
		   
		   (mzprizm:color-syntax expanded edit)
		   (send edit end-edit-sequence)
		   (read-loop)))))
	 (zodiac:transmit-to-device 'break))))))

(define mrslatex:transform mzprizm:transform)

; ----------------------------------------------------------------------

