
;;; Show how to derive specicalized edit windows

; This is a fairly articificial example at the moment: it derives
;  a new window that automatically capitalizes any characters you type.

; This is the new edit class, which is where the key is captured
;  and captialized (if it isn't remapped)
(define auto-cap-media-edit%
  (make-class mred:edit%
	      (public 
	       (on-default-char
		(lambda (key)
		  (let ((code (send key get-key-code)))
		    (if (< code 128)
			(send key set-key-code
			      (char->integer 
			       (char-upcase
				(integer->char code)))))
		    ((ivar super on-default-char) key)))))))

; This is the new frame class. Notice how the "edit%" variable
;  is overidden so that the standard frame implementation is
;  unchanged. This could be viewed as a way to implement functors.
;  Of course, you could create a function to build a frame class
;  which takes classes as arguments (and that might look even more
;  like a functor), but this way of doing things allows default
;  subpart classes to be specified in the base frame class.
(define auto-cap-frame%
  (make-class mred:frame%
	      (public 
	       [edit% auto-cap-media-edit%])))

; Make an empty autocap frame
(define make-auto-cap-frame
  (lambda ()
    (make-object auto-cap-frame%)))
