
(define mred:scheme-connection%
  (make-class wx:connection%
	      (inherit execute)
	      (public 
	       [on-execute
		(lambda (topic data len format)
		  (let ([str (expr->string (eval-string data))])
		    (execute str)))])))

(define mred:text-connection%
  (make-class wx:connection%
	      (inherit execute)
	      (private [queue ()])
	      (public 
	       [on-execute
		(lambda (topic data len format)
		  (set! queue (append queue (list data))))]
	       [send
		(lambda (s)
		  (execute s))]
	       [get
		(lambda ()
		  (if (null? queue)
		      #f
		      (let ([data (car queue)])
			(set! queue (cdr queue))
			data)))])))

; A server that reads strings a S-expressions and returns the evaluated
;  value as a string
(define mred:scheme-server%
  (make-class wx:server%
	      (public 
	       [on-accept-connection
		(lambda (topic)
		  (make-object mred:scheme-connection%))])))

; A server that accepts a string and just remembers it until you
;  invoke the connection's "get" method. Send strings back out with
;  the connection's "send" method.
(define mred:text-server%
  (make-class wx:server%
	      (public 
	       connection
	       [on-accept-connection
		(lambda (topic)
		  (set! connection (make-object mred:text-connection%))
		  connection)])))

; Client version of the above.
(define mred:text-client%
  (make-class wx:client%
	      (public
	       connection
	       [on-make-connection
		(lambda ()
		  (set! connection (make-object mred:text-connection%))
		  connection)])))

;;;;;;;;;;;;;;;;;;;;;

;; Requires extra chez library:
(define chez-console-frame%
  (make-class mred:console-frame%
	      (public
	       port
	       [edit%
		(make-class mred:scheme-edit%
			    (inherit execute)
			    (public
			     connection
			     [local-connection%
			      (make-class wx:connection%
					  (public 
					   [on-execute
					    (lambda (topic data len format)
					      (display data this-out)
					      (insert-prompt))]
					   [send
					    (lambda (s)
					      (execute s))]))]
			     
			     [do-eval
			      (lambda (str)
				(if (void? connection)
				    (begin
				      (display "Not ready yet" this-err)
				      (newline this-err))
				    (begin
				      (set! prompt-mode #f)
				      (send connection send str))))])
			    
			    (lambda args
			      (let ([server
				     (make-object
				      (make-class 
				       wx:server%
				       (public 
					[on-accept-connection
					 (lambda (topic)
					   (if (string=? topic "STDIO")
					       ()
					       (begin
						 (set! connection 
						       (make-object 
							local-connection%))
						 connection)))])))])
				(send server create port))
			      (apply-super-init args)))])
	      (lambda (p . opt)
		(set! port p)
		(apply-super-init opt))))

