
(define jam:frame%
  (let-enumerate
   ((FILE-LOAD
     FILE-LOAD-INTERACTION
     FILE-SAVE
     FILE-SAVE-AS
     FILE-RELOAD
     FILE-RESET
     FILE-QUIT
     FILE-END-OF-MENU))
   (make-class wx:frame%
	       (inherit
		show  get-client-size)
	       (class
		(WIDTH 600)
		(HEIGHT 800)
		(BUTTON-MARGIN 5)
		(INTERACTION-INSET 80)
		
		(SPLIT-NAME "Define Program")
		(CLEAR-NAME "Erase Program")
		
		(UPDATE-NAME "Update Values")
		 (CHECK-NAME "Check Syntax"))
	       
	       (class
		(canvas% wx:media-canvas%)
		(edit% mred:std-edit%)
		(button% wx:button%)
		(menu% wx:menu%)
		(menu-bar% wx:menu-bar%)
		(panel% wx:panel%))
	       
	       (private 
		let-edit
		in-edit
		let-canvas
		in-canvas
		menu-bar
		
		button-panel
		
		split-clear-button
		update-button
		check-button

		interaction-boxes
		
		(let-mode #f)
		edit-offset 
		other-offset)
	       
	       (public 
		[on-size
		 (lambda ignored
		   (let ((client-w (box 0))
			 (client-h (box 0))
			 (button-h (box 0))
			 (button-w (box 0)))
		     (get-client-size client-w client-h)
		     (send split-clear-button get-size 
			   button-w button-h)
		     (let* ((button-height (+ (unbox button-h)
					      (* 2 BUTTON-MARGIN)))
			    (width (unbox client-w))
			    (height (- (unbox client-h)
				       button-height))
			    (height (if (< height 0)
					0
					height)))
		       (send button-panel set-size  
			     0 0
			     width button-height)
		       (if let-mode
			   (let ((half-height (/ height 2)))
			     (send let-canvas set-size 
				   0 button-height
				   width half-height)
			     (send in-canvas set-size 
				   0 (+ button-height half-height)
				   width half-height))
			   (begin
			     (send let-canvas set-size 
				   (* 2 width) (* 2 height)
				   10 10)
			     (send in-canvas set-size 
				   0 button-height
				   width height)))
		       (let ([width (- width INTERACTION-INSET)])
			 (map (lambda (i-box)
				(let ([e (send i-box get-this-media)])
				  (send e set-max-width  width)
				  (send e set-min-width  width)))
			      interaction-boxes)))))]
		[on-menu-command
		 ; Handle menu selections
		 (lambda (op)
		   (cond
		    ((> op other-offset) 'bad)
		    ((> op edit-offset)
		     (let ((edit (cond
				  ((send in-canvas is-focus-on?)
				   in-edit)
				  ((and let-mode
					(send let-canvas is-focus-on?))
				   let-edit)
				  (else '()))))
		       (if (not (null? edit))
			   (send edit do-edit (- op edit-offset)))))
		    ((= op FILE-LOAD) (send edit load-file ))
		    ((= op FILE-SAVE) (send edit save-file
					    (send edit filename)))
		    ((= op FILE-SAVE-AS) (send edit save-file))
		    ((= op FILE-RELOAD) (send edit load-file 
					      (send edit filename)))
		    ((= op FILE-QUIT) (show  #f))))])
	       
	       (public
		[on-split-or-clear
		 (lambda (button event)
		   (set!  let-mode (not let-mode))
		   (send split-clear-button set-label 
			 (if let-mode CLEAR-NAME SPLIT-NAME))
		   (if (not let-mode)
		       (send let-edit clear ))
		   (on-size))]
		[on-update
		 (lambda (button event)
		   (display "Update!")
		   (newline))]
		[on-check
		 (lambda (button event)
		   (display "Check!")
		   (newline))]
		[new-interaction
		 (lambda ()
		   (let ((i-box (make-object wx:media-snip% () #t)))
		     (set! interaction-boxes (cons i-box '()))
		     (send* in-edit
			    (begin-edit-sequence)
			    (lock #f)
			    (insert  "> ")
			    (insert  i-box)
			    (insert  #\newline)
			    (lock #t)
			    (set-caret-owner  i-box)
			    (end-edit-sequence))))])
	       
	       (lambda ()
		 (super-init () "Jam!" -1 -1 WIDTH HEIGHT
			     (+ wx:const-default-frame wx:const-sdi)
			     "frame")
		 
		 (set! button-panel (make-object panel% this))
		 (set! split-clear-button 
		       (make-object button%
				    button-panel
				    on-split-or-clear
				    SPLIT-NAME
				    -1 BUTTON-MARGIN))
		 (set! update-button
		       (make-object button%
				    button-panel
				    on-update
				    UPDATE-NAME))
		 (set! check-button
		       (make-object button%
				    button-panel
				    on-check
				    CHECK-NAME))

		 (set! in-edit (make-object edit%))
		 (set! let-edit (make-object edit%))
		 
		 (set! in-canvas (make-object canvas% this))
		 (send in-canvas set-media  in-edit)

		 (set! let-canvas (make-object canvas% this))
		 (send let-canvas set-media  let-edit)

		 (new-interaction)

		 ; Build the menus:
		 (let ((file-menu (make-object menu%))
		       (edit-menu (make-object menu%)))
		   (send file-menu append  FILE-LOAD "Load...")
		   (send file-menu append  FILE-LOAD-INTERACTION 
			 "Load Interaction...")
		   (send file-menu append-separator )
		   (send file-menu append  FILE-SAVE "Save")
		   (send file-menu append  FILE-SAVE-AS "Save As...")
		   (send file-menu append-separator )
		   (send file-menu append  FILE-RELOAD "Reload")
		   (send file-menu append  FILE-RESET "Clear Program")
		   (send file-menu append-separator )
		   (send file-menu append  FILE-QUIT "Quit")

		   ; Use the built-in menu item lists for the edit menu:
		   (set!  edit-offset FILE-END-OF-MENU)
		   (set! other-offset
			 (send in-edit append-edit-items  
			       edit-menu edit-offset))

		   ; Build and install the menu bar:
		   (let ((menu-bar (make-object menu-bar%
						(list file-menu edit-menu)
						(list "File" "Edit"))))
		     ((ivar set-menu-bar ) menu-bar)))
		 (show  #t)))))

