
; Demo make-input-port & make-output-port

(define list->port
  (lambda (l)
    (make-input-port (lambda ()
		       (if (null? l)
			   eof
			   (let ([first (car l)])
			     (set! l (cdr l))
			     first)))
		     (lambda ()
		       #t)
		     (lambda ()
		       'done))))

(define test-port (list->port (string->list "matthew")))
(read-char test-port) ; => #\m
(peek-char test-port) ; => #\a
(read-char test-port) ; => #\a
(close-input-port test-port)

(define port-into-box
  (lambda (b)
    (if (not (box? b))
	(error "port-into-box: expected a destination box"))
    (set-box! b "")
    (make-output-port (lambda (s)
			(set-box! b (string-append (unbox b) s)))
		      (lambda ()
			'done))))

(define output-box (box 0))
(define test-port (port-into-box output-box))
(display "hello" test-port)
(display " there" test-port)
(unbox output-box) ; => "hello there"
(close-output-port test-port)
