
; Test/example of wxScheme's object system

(define c1 
  (let ((v 10))
    (make-class '()
		(class (x 1) (y 2))
		(private (a 0) (b3 3))
		(public (b1 2) (b2 2) (e 0))
		(public (c 3) (d 7)
			(f-1-a (lambda () a))
			(f-1-b1 (lambda () b1))
			(f-1-b2 (lambda () b2))
			(f-1-c (lambda () c))
			(f-1-v (lambda () v))
			(f-1-top-a (lambda () (ivar this a)))
			(f-1-other-e (lambda (o) (ivar o e))))
		(lambda (x)
		  (set! e x)
		  (set! a x)))))
  
(define o1 (make-object c1 0))

(define c2 
  (let ((v 20))
    (make-class c1
		(inherit b2)
		(public (a 4) (b1 5) (c 6)
			(f-2-a (lambda () a))
			(f-2-b1 (lambda () b1))
			(f-2-b2 (lambda () b2))
			(f-2-c (lambda () c))
			(f-2-v (lambda () v)))
		(private (y 3))
		(lambda ()
		  (super-init 1))
		(lambda (name)
		  `(unbound ,name)))))

(define o2 (make-object c2))

(define display-test 
  (lambda (p v)
    (display p)
    (display " ")
    (display v)
    (newline)))

(display-test "Should be 1:" (cvar c1 x))

(define error-1 (lambda () (display-test "Should be error:" (ivar o1 a))))
(display-test "Should be 4:" (ivar o2 a))
(define error-2 (lambda () (display-test "Should be error:" (ivar c1 o2 a))))
(display-test "Should be 4:" (ivar c2 o2 a))

(display-test "Should be 0:" (send o1 f-1-a))
(display-test "Should be 1:" (send o2 f-1-a))
(display-test "Should be 4:" (send o2 f-2-a))

(define error-3 (lambda () (display-test "Should be error:" (send o1 f-1-top-a))))
(display-test "Should be 4:" (send o2 f-1-top-a))

(display-test "Should be 5:" (ivar o2 b1))
(display-test "Should be (unbound b3):" (ivar o2 b3))
(display-test "Should be 2:" (ivar c1 o2 b1))
(display-test "Should be 5:" (ivar c2 o2 b1))

(display-test "Should be 2:" (send o1 f-1-b1))
(display-test "Should be 2:" (send o1 f-1-b2))
(display-test "Should be 5:" (send o2 f-1-b1))
(display-test "Should be 2:" (send o2 f-1-b2))
(display-test "Should be 5:" (send o2 f-2-b1))
(display-test "Should be 2:" (send o2 f-2-b2))

(display-test "Should be 3:" (ivar o1 c))
(display-test "Should be 6:" (ivar o2 c))
(display-test "Should be 3:" (ivar c1 o2 c))
(display-test "Should be 6:" (ivar c2 o2 c))

(display-test "Should be 3:" (send o1 f-1-c))
(display-test "Should be 6:" (send o2 f-1-c))
(display-test "Should be 6:" (send o2 f-2-c))

(display-test "Should be 7:" (ivar o1 d))
(display-test "Should be 7:" (ivar o2 d))

(display-test "Should be 10:" (send o1 f-1-v))
(display-test "Should be 10:" (send o2 f-1-v))
(display-test "Should be 20:" (send o2 f-2-v))

(display-test "Should be 0:" (send o1 f-1-other-e o1))
(display-test "Should be 1:" (send o1 f-1-other-e o2))

(display-test "Should be 2:" (ivar o2 y))

(define error-4 (lambda () (display-test "Should be error:" (ivar c1 o2 A))))

(define test-error 
  (lambda (thunk)
    (let ((old-error-handler error-handler))
      (call/ec
       (lambda (exit)
	 (let ((new-error-handler (lambda errdata
				    (exit #f))))
	   (set! error-handler new-error-handler)
	   (thunk))))
      (set! error-handler old-error-handler))))

; Nothing should be printed from this:
(map test-error (list error-1 error-2 error-3 error-4))
