;; Teiresias tutorial part 1

;; This section of the tutorial examplifies how each
;; kind of program term induces a constraint.

;; To analyze this program, 
;; 1. Load it onto Teiresias,
;; 2. Select the "Analyze" option in the "Analysis" menu

;; ==================================================
;; VARIABLES

(define x 1)

x ;; label L-1

;; Click on the second x to see its type.
;; Right-click on the type to see where it comes from.

;; The resulting arrow corresponds to the constraint:
;;       E(x) is a subset of  E(L-1)

;; --------------------------------------------------
;; CONSTANTS

3
'a
#t

;; Clicking on these constants shows that they are
;; assigned appropriate types.

;; --------------------------------------------------
;; CONS

(define p1 (cons 4 'Teiresias))

;; Clicking on p1 
;; (or on the leftmost paren of the cons expression)
;; shows that it is assigned a type:
;;      (cons num sym)
;; where num is the type for 4,
;; and sym is the type for 'Teiresias

;; --------------------------------------------------
;; CAR

(define p2 (cons 4 'Teiresias))

(car p2)

;; Click on the left paren of (car p2)
;; Right-click on this type to see where it comes from.

;; The resulting arrow corresponds to the subset
;;  constraint in the rule for car.

;; --------------------------------------------------
;; LAMBDA

(define f1 (lambda (x) x))

;; Since f1 is never applied, 
;; it is never passed any values,
;; and never produces any results.

;; --------------------------------------------------
;; APPLICATION

(define f2 
  (lambda (x) 
    (cons x x)))

(f2 'Teiresias)

;; The source arrows for x and the application expr
;; correspond to the subset constraints produced by the 
;; application rule.

;; ==================================================







