;; Teiresias tutorial part 3

;; A series of examples on the function sum,
;; which sums the leaves in a binary tree.

;; ==================================================
;; Checking faulty sum 
;; [missing natural recursion, approx types]

(define sum1
  (lambda (atree)
    (cond
      ((number? atree) atree)
      (else (+ (sum1 (car atree)) 
               (cdr atree))))))

(define tree (cons (cons 1 2) (cons 3 4)))

(define sum1@tree (sum1 tree))

;; ----------------------------------------------------
;; Checking correct sum 
;; [bad input, approx types]

(define sum2
  (lambda (atree)
    (cond
      ((number? atree) atree)
      (else (+ (sum2 (car atree)) 
               (sum2 (cdr atree)))))))

(define tree3 (cons 3 '()))

(define sum2@tree3 (sum2 tree3))
  
;; ----------------------------------------------------
;; Checking sum on read-input with faulty reader 
;; [recursive types]

(define sum3
  (lambda (atree)
    (cond
      ((number? atree) atree)
      (else (+ (sum3 (car atree)) 
               (sum3 (cdr atree)))))))

(define tree-reader-f
  (lambda (input)
    (cond
      ((number? input) 
       input)
      ((list? input)
       (cons (tree-reader-f (car input))
             (tree-reader-f (cdr input))))
      (else
       (error 'tree-reader-f "not a tree ~s" input)))))

(define result-of-sum3 (sum3 (tree-reader-f (read))))

;; ----------------------------------------------------
;; Checking sum on read-input with correct reader 
;; [rec types]

(define sum4
  (lambda (atree)
    (cond
      ((number? atree) atree)
      (else (+ (sum4 (car atree)) 
               (sum4 (cdr atree)))))))

(define tree-reader
  (lambda (input)
    (cond
      ((number? input) 
       input)
      ((pair? input)
       (cons (tree-reader (car input))
             (tree-reader (cdr input))))
      (else 
       (error 'tree-reader "not a tree ~s" input)))))

(define sum-up
  (lambda ()
    (sum4 (tree-reader (read)))))

(define result-of-sum-up (sum-up))


;; ==================================================
