
(define plt-dir
  (let ([d (getenv "PLTHOME")])
    (if d 
	d 
	(let ([wd (current-directory)])
	  (let-values ([(base name dir?)
			(split-path wd)])
	     (if (and (string? base)
		      (directory-exists? (build-path base
						     "zodiac")))
		 base
		 "/usr/local/lib/plt"))))))

(require-library "pretty.ss")
(require-library "trigger.ss")
(current-print pretty-print-handler)

; One value exported from zodiac to user global space:
(define zodiac:dt-extend-global-env #f)

(let ([exported-eval-box (box #f)]
      [exported-dt-box (box #f)]
      [trigger (make-trigger)])
  (eval ; This should be spawn-eval, but zodiac's expander isn't ready
   `(begin
      (current-output-port ,(current-output-port))
      (current-error-port ,(current-error-port))

      (require-library "mzlib.ss")

      (define zodiac:home-directory 
	(build-absolute-path ,plt-dir "zodiac"))
      
      (load (build-absolute-path zodiac:home-directory "load.ss"))
      (zodiac:require (build-relative-path "Source" "do-load"))
      (fetch "mzscheme")
      (aries)
      (rice)

      (define zodiac:expand-action ,eval)

      (set-box! ,exported-eval-box
	(lambda (orig-eval e)
	  (orig-eval (let* (; [e (expand-defmacro e)]
			    [v (zodiac:expr-stripper (zodiac:expand e))])
		       v))))
      (set-box! ,exported-dt-box zodiac:dt-extend-global-env)
      
      (trigger-hit ,trigger)))

  (trigger-block trigger #t)

  (set! zodiac:dt-extend-global-env (unbox exported-dt-box))

  (require-library "match.ss") ; to get define-structure

  (let ([rice:home-directory (build-absolute-path plt-dir "rice")])
    (load/cd (build-absolute-path rice:home-directory "ricedefs.ss"))
    (load/cd (build-absolute-path rice:home-directory "x-rice.ss")))
    
  (let ([orig-eval (current-eval)]
	[z-eval (unbox exported-eval-box)])
    (current-eval
     (lambda (e)
       (z-eval orig-eval e)))))


