(define zodiac:fifo-port 'unset-fifo-port)
(define zodiac:s2d-filename 'unset-s2d-filename)
(define zodiac:open-fifo
  (lambda (filename)
    (set! zodiac:fifo-port (open-output-file filename 'truncate))))

(define zodiac:s2d-file
  (lambda (filename)
    (set! zodiac:s2d-filename filename)))

(define zodiac:transmit-to-device
  (lambda messages
    (let ([hd (car messages)]
	  [tl (cdr messages)])
      (let ([s2d-port (open-output-file zodiac:s2d-filename 'truncate)])
	(let loop ([msgs tl])
	  (cond
	   [(null? msgs) 'done]
	   [(null? (cdr msgs)) (for-each (lambda (msg)
					   (pretty-print msg s2d-port))
					 (car msgs))]
	   [else (pretty-print (car msgs) s2d-port)
		 (loop (cdr msgs))]))
	(flush-output s2d-port)
	(close-output-port s2d-port))
      (display hd zodiac:fifo-port) (display #\newline zodiac:fifo-port)
      (flush-output zodiac:fifo-port))))

(if zodiac:print-on-startup
  (printf "Emacs configured~n"))
