(define zodiac:expand-file
  (let ((with-input-from-file with-input-from-file)
	 (input-port? input-port?) (output-port? output-port?)
	   (read read) (eof-object? eof-object?) (pair? pair?)
	   (eq? eq?) (car car) (caddr caddr) (cadr cadr)
	   (expand expand) (pretty-print pretty-print) (newline newline))
    (case-lambda
      ((input-file output-file)
	(let ((in-port (if (input-port? input-file) input-file
			 (open-input-file input-file)))
	       (out-port (if (output-port? output-file) output-file
			   (open-output-file output-file))))
	  (let loop ()
	    ((let ((r (read in-port)))
	       (if (not (eof-object? r))
		 (begin
		   (if (and (pair? r)
			 (eq? 'define-term (car r)))
		     (begin
		       (fprintf out-port "(zodiac:dt-extend-global-env~n")
		       (fprintf out-port "  (quote ~s)~n  " (cadr r))
		       (fluid-let ((zodiac:expand-action
				     (lambda (e) (write e out-port))))
			 (expand r))
		       (fprintf out-port ")~n~n"))
		     (pretty-print r out-port))
		   (newline out-port)
		   (loop))))))))
      ((input-file)
	(zodiac:expand-file input-file (current-output-port)))
      (()
	(zodiac:expand-file (current-input-port) (current-output-port))))))

(if zodiac:print-on-startup
  (printf "Expand-file loaded~n"))
