(define structure? struct?)

(define zodiac:values values)
(define zodiac:call-with-values call-with-values)

(define make-syntax-object
(let ((vector vector))
(lambda (expression wrap)
((lambda ()
(vector 'syntax-object expression wrap))))))
(define syntax-object?
(let ((vector? vector?) (vector-length vector-length) (= =)
(eq? eq?) (vector-ref vector-ref))
(lambda (x)
(if (vector? x)
(if (= (vector-length x) 3)
(eq? (vector-ref x 0) 'syntax-object)
#f)
#f))))
(define syntax-object-expression
(let ((vector-ref vector-ref))
(lambda (x) (vector-ref x 1))))
(define syntax-object-wrap
(let ((vector-ref vector-ref))
(lambda (x) (vector-ref x 2))))
(define set-syntax-object-expression!
(let ((vector-set! vector-set!))
(lambda (x update) (vector-set! x 1 update))))
(define set-syntax-object-wrap!
(let ((vector-set! vector-set!))
(lambda (x update) (vector-set! x 2 update))))

(define make-zodiac:location
(let ((vector vector))
(lambda (line column offset file)
((lambda ()
(vector 'zodiac:location line column offset file))))))
(define zodiac:location?
(let ((vector? vector?) (vector-length vector-length) (vector-ref vector-ref)
(eq? eq?) (= =))
(lambda (x)
(if (vector? x)
(if (= (vector-length x) 5)
(eq? (vector-ref x 0) 'zodiac:location)
#f)
#f))))
(define zodiac:location-line
(let ((vector-ref vector-ref))
(lambda (x) (vector-ref x 1))))
(define zodiac:location-column
(let ((vector-ref vector-ref))
(lambda (x) (vector-ref x 2))))
(define zodiac:location-offset
(let ((vector-ref vector-ref))
(lambda (x) (vector-ref x 3))))
(define zodiac:location-file
(let ((vector-ref vector-ref))
(lambda (x) (vector-ref x 4))))
(define set-zodiac:location-line!
(let ((vector-set! vector-set!))
(lambda (x update) (vector-set! x 1 update))))
(define set-zodiac:location-column!
(let ((vector-set! vector-set!))
(lambda (x update) (vector-set! x 2 update))))
(define set-zodiac:location-offset!
(let ((vector-set! vector-set!))
(lambda (x update) (vector-set! x 3 update))))
(define set-zodiac:location-file!
(let ((vector-set! vector-set!))
(lambda (x update) (vector-set! x 4 update))))

(define-structure (zodiac:token text type start finish))

(define-structure (zodiac:open-paren text location))
(define-structure (zodiac:close-paren text location))
(define-structure (zodiac:phantom-paren kind location))

(define-structure (zodiac:period location))

(define-structure (zodiac:eof location))

(define-structure (zodiac:string text start finish))
(define-structure (zodiac:boolean text start finish))
(define-structure (zodiac:char text start finish))
(define-structure (zodiac:symbol text start finish))
(define-structure (zodiac:number text start finish))

(define-structure (zodiac:list contents length open close))
(define-structure (zodiac:improper-list contents length open close))
(define-structure (zodiac:vector contents length open close))

(define-structure (zodiac:back-entry location boxes))

;(define-structure (zodiac:delay-form expr open close back))
;(define-structure (zodiac:if-form test then else open close back))
;(define-structure (zodiac:lambda-form args body level open close back))
;(define-structure (zodiac:set!-form var val open close back))
;(define-structure (zodiac:quote-form expr open close back))
;(define-structure (zodiac:begin-form first rest open close back))
;(define-structure (zodiac:let-form vars vals body level open close back))
;(define-structure (zodiac:letrec-form vars vals body level open close back))
;(define-structure (zodiac:define-form name value open close back))

;(define-structure (zodiac:app fun args open close back))

(define-structure (zodiac:lexical-varref var binding back))
(define-structure (zodiac:top-level-varref var back))
(define-structure (zodiac:unbound-varref var back))

(define-structure (zodiac:unchanged body open close))

(define-structure (zodiac:bound var box))
(define-structure (zodiac:binding level offset var))
