(define zodiac:top-level-contn
  (let ((tlc 'dummy-zodiac:top-level-contn))
    (case-lambda
      (() tlc)
      ((c) (set! tlc c)))))

(define zodiac:report-dynamic-error
  (let ((apply apply))
    (lambda (message object args)
      (let ((location (zodiac:determine-start-location object)))
	(apply zodiac:transmit-to-device
	  `(dynamic-error ,message
	     ,@(zodiac:location->list location)
	     ,args)))
      ((zodiac:top-level-contn) (zodiac:void)))))

(define zodiac:report-static-error
  (let ((apply apply))
    (lambda (message object)
      (let ((location (zodiac:determine-start-location object)))
	(apply zodiac:transmit-to-device
	  `(static-error ,message
	     ,@(zodiac:location->list location)
	     ())))
      ((zodiac:top-level-contn) (zodiac:void)))))

(define zodiac:report-loaded
  (lambda (file-key)
    (zodiac:transmit-to-device 'loaded file-key '())))

(define zodiac:report-result
  (lambda (file-key values)
    (zodiac:transmit-to-device 'result file-key values)))

(if zodiac:print-on-startup
  (printf "Communications loaded~n"))
