; -*- Scheme -*-

(define scan-driver
  (lambda (port handlers chars length)
    (call/ec
      (lambda (escape)
	(let loop
	   ((handlers handlers)
	     (chars chars)
	     (length length))
	  (let ((c (read-char port)))
	    (if (eof-object? c)
	      ...
	      (let ((handler (handler-for handlers c)))
		(handler loop escape c chars length)))))))))

(define scan
  (lambda (port)
    (scan port top-level-handlers '() 0)))

(define character-set-size 256)

(define make-handlers
  (lambda (default-handler)
    (make-vector character-set-size default-handler)))

(define set-handler-for
  (lambda (handlers char handler)
    (vector-set! handlers (char->integer char) handler)))

(define set-handlers-for
  (lambda (handlers chars handler)
    (map (lambda (c) (set-handler-for handlers c handler)) chars)))

(define handler-for
  (lambda (handlers char)
    (vector-ref handlers (char->integer char))))

(define default-top-level-handlers
  (let ((h
	  (make-handlers
	    (lambda (looper escaper new-char old-chars length)
	      (error)))))
    
