(define test-for-error
  (lambda (exn-tester k)
    (current-exception-handler
      (lambda (exn)
	(if (exn-tester exn)
	  (k 'okay)
	  ((current-error-handler)))))
    (lambda (value) 
      (printf "~s~n" value))))

(begin
  (call/ec
   (lambda (k)
     ((test-for-error exn:user? k) (error 'foo "bar"))))
  (call/ec
    (lambda (k)
      ((test-for-error exn:variable? k) unbound-identifier!)))
  (call/ec
    (lambda (k)
      ((test-for-error exn:application:non-procedure? k)
       ('non-function))))
  (call/ec
    (lambda (k)
      ((test-for-error exn:application:arity? k)
       ((lambda (x) x)))))
  (call/ec
   (lambda (k)
     ((test-for-error exn:application:type? k) (#%car 3))))
  (call/ec
   (lambda (k)
     ((test-for-error exn:application:range:bounds:vector? k)
      (vector-ref (vector) 1))))
  (call/ec
   (lambda (k)
     ((test-for-error exn:application:range:bounds:string? k)
      (string-ref "" 1))))
  (call/ec
   (lambda (k)
     ((test-for-error exn:application:range:list? k)
      (list-ref '() 1))))
  (call/ec
   (lambda (k)
     ((test-for-error exn:application:list-sizes? k)
      (map + '(1 2) '(1)))))
  (call/ec
   (lambda (k)
     ((test-for-error exn:application:math:zero? k)
      (/ 1 0))))
  (printf "All tests passed~n"))
