(define zodiac:home-directory
  (if (bound? 'zodiac:home-directory)
    zodiac:home-directory
    (build-absolute-path "/home/shriram/Works/Zodiac")))
(define zodiac:scheme-suffix ".ss")
(define zodiac:macro-lib-from 'compiled)

(define zodiac:print-on-startup #f)

(define zodiac:scheme-type
  (let ((scheme-type "mzscheme"))
    (let ((length length) (list->string list->string) (map map)
	   (char-downcase char-downcase) (car car) (string->list string->list)
	   (error error))
      (lambda args
	(case (length args)
	  ((0) scheme-type)
	  ((1) (set! scheme-type
		 (list->string
		   (map char-downcase (string->list (car args))))))
	  (else (error 'zodiac:scheme-type "invalid arity")))))))

(define zodiac:resolve-filename
  (let ((string-append string-append))
    (lambda (filename)
      (string-append (build-absolute-path zodiac:home-directory filename)
	zodiac:scheme-suffix))))

(define zodiac:require
  (let ((loaded '()))
    (let ((member member) (load load) (cons cons))
      (lambda (filename)
	(if (member filename loaded)
	  #t
	  (begin
	    (load (zodiac:resolve-filename filename))
	    (set! loaded (cons filename loaded))
	    'loaded))))))

(if zodiac:print-on-startup
  (printf "Zodiac is rooted in ~a~n" zodiac:home-directory))

(define zodiac:scheme-require
  (let ((string-append string-append))
    (lambda (path)
      (zodiac:require (build-relative-path path (zodiac:scheme-type))))))

(define fetch
  (let ((null? null?) (not not) (printf printf))
    (lambda args
      (if (not (null? args))
	(zodiac:scheme-type (car args)))
      (zodiac:scheme-require (build-relative-path "Source" "Scheme"))
      (zodiac:require (build-relative-path "Source" "support"))
      (zodiac:require (build-relative-path "Source" "zodiac"))
      (zodiac:require (build-relative-path "Source" "do-load"))
      (zodiac:require (build-relative-path "Source" "Macros" "loadex"))
      (zodiac:require (build-relative-path "Source" "back"))
      (zodiac:require (build-relative-path "Source" "comm"))
      (zodiac:require (build-relative-path "Devices" "Terminal" "terminal"))
      (zodiac:require (build-relative-path "Source" "Macros" "fexpand"))
      (if zodiac:print-on-startup
	(printf "Zodiac ready~n")))))

(define (aries)
  (zodiac:require (build-relative-path "Packages" "Aries" "Source" "aries")))

(define (rice)
  'foo)
;  (zodiac:require (build-relative-path "Packages" "Aries" "Source" "rice")))
